// --------------------------------------------------------------------
// Copyright (c) 2007 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
//
// Major Functions:	DE2P TOP LEVEL 
//
// --------------------------------------------------------------------
//
// Revision History :
// --------------------------------------------------------------------
//   Ver  :| Author            :| Mod. Date :| Changes Made:
//   V1.0 :| Johnny FAN        :| 07/07/09  :| Initial Revision
//   V1.0 :| Joe Yang          :| 07/08/02  :| PIP 
// --------------------------------------------------------------------

module DE2_70_TV_PIP
	(
		////////////////////	Clock Input	 	////////////////////	 
		iCLK_28,						//  28.63636 MHz
		iCLK_50,						//	50 MHz
		iCLK_50_2,						//	50 MHz
		iCLK_50_3,						//	50 MHz
		iCLK_50_4,						//	50 MHz
		iEXT_CLOCK,						//	External Clock
		////////////////////	Push Button		////////////////////
		iKEY,							//	Pushbutton[3:0]
		////////////////////	DPDT Switch		////////////////////
		iSW,							//	Toggle Switch[17:0]
		////////////////////	7-SEG Dispaly	////////////////////
		oHEX0_D,						//	Seven Segment Digit 0
		oHEX0_DP,						//  Seven Segment Digit 0 decimal point
		oHEX1_D,						//	Seven Segment Digit 1
		oHEX1_DP,						//  Seven Segment Digit 1 decimal point
		oHEX2_D,						//	Seven Segment Digit 2
		oHEX2_DP,						//  Seven Segment Digit 2 decimal point
		oHEX3_D,						//	Seven Segment Digit 3
		oHEX3_DP,						//  Seven Segment Digit 3 decimal point
		oHEX4_D,						//	Seven Segment Digit 4
		oHEX4_DP,						//  Seven Segment Digit 4 decimal point
		oHEX5_D,						//	Seven Segment Digit 5
		oHEX5_DP,						//  Seven Segment Digit 5 decimal point
		oHEX6_D,						//	Seven Segment Digit 6
		oHEX6_DP,						//  Seven Segment Digit 6 decimal point
		oHEX7_D,						//	Seven Segment Digit 7
		oHEX7_DP,						//  Seven Segment Digit 7 decimal point
		////////////////////////	LED		////////////////////////
		oLEDG,							//	LED Green[8:0]
		oLEDR,							//	LED Red[17:0]
		////////////////////////	UART	////////////////////////
		oUART_TXD,						//	UART Transmitter
		iUART_RXD,						//	UART Receiver
		oUART_CTS,          			//	UART Clear To Send
		iUART_RTS,          			//	UART Requst To Send
		////////////////////////	IRDA	////////////////////////
		oIRDA_TXD,						//	IRDA Transmitter
		iIRDA_RXD,						//	IRDA Receiver
		/////////////////////	SDRAM Interface		////////////////
		DRAM_DQ,						//	SDRAM Data bus 32 Bits
		oDRAM0_A,						//	SDRAM0 Address bus 12 Bits
		oDRAM1_A,						//	SDRAM1 Address bus 12 Bits
		oDRAM0_LDQM0,					//	SDRAM0 Low-byte Data Mask 
		oDRAM1_LDQM0,					//	SDRAM1 Low-byte Data Mask 
		oDRAM0_UDQM1,					//	SDRAM0 High-byte Data Mask
		oDRAM1_UDQM1,					//	SDRAM1 High-byte Data Mask
		oDRAM0_WE_N,					//	SDRAM0 Write Enable
		oDRAM1_WE_N,					//	SDRAM1 Write Enable
		oDRAM0_CAS_N,					//	SDRAM0 Column Address Strobe
		oDRAM1_CAS_N,					//	SDRAM1 Column Address Strobe
		oDRAM0_RAS_N,					//	SDRAM0 Row Address Strobe
		oDRAM1_RAS_N,					//	SDRAM1 Row Address Strobe
		oDRAM0_CS_N,					//	SDRAM0 Chip Select
		oDRAM1_CS_N,					//	SDRAM1 Chip Select
		oDRAM0_BA,						//	SDRAM0 Bank Address
		oDRAM1_BA,	 					//	SDRAM1 Bank Address
		oDRAM0_CLK,						//	SDRAM0 Clock
		oDRAM1_CLK,						//	SDRAM0 Clock
		oDRAM0_CKE,						//	SDRAM0 Clock Enable
		oDRAM1_CKE,						//	SDRAM1 Clock Enable
		////////////////////	Flash Interface		////////////////
		FLASH_DQ,						//	FLASH Data bus 15 Bits (0 to 14)
		FLASH_DQ15_AM1,					//  FLASH Data bus Bit 15 or Address A-1
		oFLASH_A,						//	FLASH Address bus 26 Bits
		oFLASH_WE_N,					//	FLASH Write Enable
		oFLASH_RST_N,					//	FLASH Reset
		oFLASH_WP_N,					//	FLASH Write Protect /Programming Acceleration 
		iFLASH_RY_N,					//	FLASH Ready/Busy output 
		oFLASH_BYTE_N,					//	FLASH Byte/Word Mode Configuration
		oFLASH_OE_N,					//	FLASH Output Enable
		oFLASH_CE_N,					//	FLASH Chip Enable
		////////////////////	SRAM Interface		////////////////
		SRAM_DQ,						//	SRAM Data Bus 32 Bits
		SRAM_DPA, 						//  SRAM Parity Data Bus
		oSRAM_A,						//	SRAM Address bus 22 Bits
		oSRAM_ADSC_N,       			//	SRAM Controller Address Status 	
		oSRAM_ADSP_N,                   //	SRAM Processor Address Status
		oSRAM_ADV_N,                    //	SRAM Burst Address Advance
		oSRAM_BE_N,                     //	SRAM Byte Write Enable
		oSRAM_CE1_N,        			//	SRAM Chip Enable
		oSRAM_CE2,          			//	SRAM Chip Enable
		oSRAM_CE3_N,        			//	SRAM Chip Enable
		oSRAM_CLK,                      //	SRAM Clock
		oSRAM_GW_N,         			//  SRAM Global Write Enable
		oSRAM_OE_N,         			//	SRAM Output Enable
		oSRAM_WE_N,         			//	SRAM Write Enable
		////////////////////	ISP1362 Interface	////////////////
		OTG_D,							//	ISP1362 Data bus 16 Bits
		oOTG_A,							//	ISP1362 Address 2 Bits
		oOTG_CS_N,						//	ISP1362 Chip Select
		oOTG_OE_N,						//	ISP1362 Read
		oOTG_WE_N,						//	ISP1362 Write
		oOTG_RESET_N,					//	ISP1362 Reset
		OTG_FSPEED,						//	USB Full Speed,	0 = Enable, Z = Disable
		OTG_LSPEED,						//	USB Low Speed, 	0 = Enable, Z = Disable
		iOTG_INT0,						//	ISP1362 Interrupt 0
		iOTG_INT1,						//	ISP1362 Interrupt 1
		iOTG_DREQ0,						//	ISP1362 DMA Request 0
		iOTG_DREQ1,						//	ISP1362 DMA Request 1
		oOTG_DACK0_N,					//	ISP1362 DMA Acknowledge 0
		oOTG_DACK1_N,					//	ISP1362 DMA Acknowledge 1
		////////////////////	LCD Module 16X2		////////////////
		oLCD_ON,						//	LCD Power ON/OFF
		oLCD_BLON,						//	LCD Back Light ON/OFF
		oLCD_RW,						//	LCD Read/Write Select, 0 = Write, 1 = Read
		oLCD_EN,						//	LCD Enable
		oLCD_RS,						//	LCD Command/Data Select, 0 = Command, 1 = Data
		LCD_D,						//	LCD Data bus 8 bits
		////////////////////	SD_Card Interface	////////////////
		SD_DAT,							//	SD Card Data
		SD_DAT3,						//	SD Card Data 3
		SD_CMD,							//	SD Card Command Signal
		oSD_CLK,						//	SD Card Clock
		////////////////////	I2C		////////////////////////////
		I2C_SDAT,						//	I2C Data
		oI2C_SCLK,						//	I2C Clock
		////////////////////	PS2		////////////////////////////
		PS2_DAT,						//	PS2 Data
		PS2_CLK,						//	PS2 Clock
		////////////////////	VGA		////////////////////////////
		oVGA_CLOCK,   					//	VGA Clock
		oVGA_HS,						//	VGA H_SYNC
		oVGA_VS,						//	VGA V_SYNC
		oVGA_BLANK_N,					//	VGA BLANK
		oVGA_SYNC_N,					//	VGA SYNC
		oVGA_R,   						//	VGA Red[9:0]
		oVGA_G,	 						//	VGA Green[9:0]
		oVGA_B,  						//	VGA Blue[9:0]
		////////////	Ethernet Interface	////////////////////////
		ENET_D,						//	DM9000A DATA bus 16Bits
		oENET_CMD,						//	DM9000A Command/Data Select, 0 = Command, 1 = Data
		oENET_CS_N,						//	DM9000A Chip Select
		oENET_IOW_N,					//	DM9000A Write
		oENET_IOR_N,					//	DM9000A Read
		oENET_RESET_N,					//	DM9000A Reset
		iENET_INT,						//	DM9000A Interrupt
		oENET_CLK,						//	DM9000A Clock 25 MHz
		////////////////	Audio CODEC		////////////////////////
		AUD_ADCLRCK,					//	Audio CODEC ADC LR Clock
		iAUD_ADCDAT,					//	Audio CODEC ADC Data
		AUD_DACLRCK,					//	Audio CODEC DAC LR Clock
		oAUD_DACDAT,					//	Audio CODEC DAC Data
		AUD_BCLK,						//	Audio CODEC Bit-Stream Clock
		oAUD_XCK,						//	Audio CODEC Chip Clock
		////////////////	TV Decoder		////////////////////////
		iTD1_CLK27,						//	TV Decoder1 Line_Lock Output Clock 
		iTD1_D,    					    //	TV Decoder1 Data bus 8 bits
		iTD1_HS,						//	TV Decoder1 H_SYNC
		iTD1_VS,						//	TV Decoder1 V_SYNC
		oTD1_RESET_N,					//	TV Decoder1 Reset
		iTD2_CLK27,						//	TV Decoder2 Line_Lock Output Clock 		
		iTD2_D,    					    //	TV Decoder2 Data bus 8 bits
		iTD2_HS,						//	TV Decoder2 H_SYNC
		iTD2_VS,						//	TV Decoder2 V_SYNC
		oTD2_RESET_N,					//	TV Decoder2 Reset
		////////////////////	GPIO	////////////////////////////
		GPIO_0,							//	GPIO Connection 0 I/O
		GPIO_CLKIN_N0,     				//	GPIO Connection 0 Clock Input 0
		GPIO_CLKIN_P0,          		//	GPIO Connection 0 Clock Input 1
		GPIO_CLKOUT_N0,     			//	GPIO Connection 0 Clock Output 0
		GPIO_CLKOUT_P0,                 //	GPIO Connection 0 Clock Output 1
		GPIO_1,							//	GPIO Connection 1 I/O
		GPIO_CLKIN_N1,                  //	GPIO Connection 1 Clock Input 0
		GPIO_CLKIN_P1,                  //	GPIO Connection 1 Clock Input 1
		GPIO_CLKOUT_N1,                 //	GPIO Connection 1 Clock Output 0
		GPIO_CLKOUT_P1                  //	GPIO Connection 1 Clock Output 1
	   
	);

//===========================================================================
// PARAMETER declarations
//===========================================================================


//===========================================================================
// PORT declarations
//===========================================================================
////////////////////////	Clock Input	 	////////////////////////
input			iCLK_28;				//  28.63636 MHz
input			iCLK_50;				//	50 MHz
input			iCLK_50_2;				//	50 MHz
input           iCLK_50_3;				//	50 MHz
input           iCLK_50_4;				//	50 MHz
input           iEXT_CLOCK;				//	External Clock
////////////////////////	Push Button		////////////////////////
input	[3:0]	iKEY;					//	Pushbutton[3:0]
////////////////////////	DPDT Switch		////////////////////////
input	[17:0]	iSW;					//	Toggle Switch[17:0]
////////////////////////	7-SEG Dispaly	////////////////////////
output	[6:0]	oHEX0_D;				//	Seven Segment Digit 0
output			oHEX0_DP;				//  Seven Segment Digit 0 decimal point
output	[6:0]	oHEX1_D;				//	Seven Segment Digit 1
output			oHEX1_DP;				//  Seven Segment Digit 1 decimal point
output	[6:0]	oHEX2_D;				//	Seven Segment Digit 2
output			oHEX2_DP;				//  Seven Segment Digit 2 decimal point
output	[6:0]	oHEX3_D;				//	Seven Segment Digit 3
output			oHEX3_DP;				//  Seven Segment Digit 3 decimal point
output	[6:0]	oHEX4_D;				//	Seven Segment Digit 4
output			oHEX4_DP;				//  Seven Segment Digit 4 decimal point
output	[6:0]	oHEX5_D;				//	Seven Segment Digit 5
output			oHEX5_DP;				//  Seven Segment Digit 5 decimal point
output	[6:0]	oHEX6_D;				//	Seven Segment Digit 6
output			oHEX6_DP;				//  Seven Segment Digit 6 decimal point
output	[6:0]	oHEX7_D;				//	Seven Segment Digit 7
output			oHEX7_DP;				//  Seven Segment Digit 7 decimal point
////////////////////////////	LED		////////////////////////////
output	[8:0]	oLEDG;					//	LED Green[8:0]
output	[17:0]	oLEDR;					//	LED Red[17:0]
////////////////////////////	UART	////////////////////////////
output			oUART_TXD;				//	UART Transmitter
input			iUART_RXD;				//	UART Receiver
output			oUART_CTS;          	//	UART Clear To Send
input			iUART_RTS;          	//	UART Requst To Send
////////////////////////////	IRDA	////////////////////////////
output			oIRDA_TXD;				//	IRDA Transmitter
input			iIRDA_RXD;				//	IRDA Receiver
///////////////////////		SDRAM Interface	////////////////////////
inout	[31:0]	DRAM_DQ;				//	SDRAM Data bus 32 Bits
output	[12:0]	oDRAM0_A;				//	SDRAM0 Address bus 12 Bits
output	[12:0]	oDRAM1_A;				//	SDRAM1 Address bus 12 Bits
output			oDRAM0_LDQM0;			//	SDRAM0 Low-byte Data Mask 
output			oDRAM1_LDQM0;			//	SDRAM1 Low-byte Data Mask 
output			oDRAM0_UDQM1;			//	SDRAM0 High-byte Data Mask
output			oDRAM1_UDQM1;			//	SDRAM1 High-byte Data Mask
output			oDRAM0_WE_N;			//	SDRAM0 Write Enable
output			oDRAM1_WE_N;			//	SDRAM1 Write Enable
output			oDRAM0_CAS_N;			//	SDRAM0 Column Address Strobe
output			oDRAM1_CAS_N;			//	SDRAM1 Column Address Strobe
output			oDRAM0_RAS_N;			//	SDRAM0 Row Address Strobe
output			oDRAM1_RAS_N;			//	SDRAM1 Row Address Strobe
output			oDRAM0_CS_N;			//	SDRAM0 Chip Select
output			oDRAM1_CS_N;			//	SDRAM1 Chip Select
output	[1:0]	oDRAM0_BA;				//	SDRAM0 Bank Address
output	[1:0]	oDRAM1_BA;		 		//	SDRAM1 Bank Address
output			oDRAM0_CLK;				//	SDRAM0 Clock
output			oDRAM1_CLK;				//	SDRAM0 Clock
output			oDRAM0_CKE;				//	SDRAM0 Clock Enable
output			oDRAM1_CKE;				//	SDRAM1 Clock Enable
////////////////////////	Flash Interface	////////////////////////
inout	[14:0]	FLASH_DQ;				//	FLASH Data bus 15 Bits (0 to 14)
inout			FLASH_DQ15_AM1;			//  FLASH Data bus Bit 15 or Address A-1
output	[25:0]	oFLASH_A;				//	FLASH Address bus 26 Bits
output			oFLASH_WE_N;			//	FLASH Write Enable
output			oFLASH_RST_N;			//	FLASH Reset
output			oFLASH_WP_N;			//	FLASH Write Protect /Programming Acceleration 
input			iFLASH_RY_N;			//	FLASH Ready/Busy output 
output			oFLASH_BYTE_N;			//	FLASH Byte/Word Mode Configuration
output			oFLASH_OE_N;			//	FLASH Output Enable
output			oFLASH_CE_N;			//	FLASH Chip Enable
////////////////////////	SRAM Interface	////////////////////////
inout	[31:0]	SRAM_DQ;				//	SRAM Data Bus 32 Bits
inout	[3:0]	SRAM_DPA; 				//  SRAM Parity Data Bus
output	[20:0]	oSRAM_A;				//	SRAM Address bus 21 Bits
output			oSRAM_ADSC_N;       	//	SRAM Controller Address Status 	
output			oSRAM_ADSP_N;           //	SRAM Processor Address Status
output			oSRAM_ADV_N;            //	SRAM Burst Address Advance
output	[3:0]	oSRAM_BE_N;             //	SRAM Byte Write Enable
output			oSRAM_CE1_N;        	//	SRAM Chip Enable
output			oSRAM_CE2;          	//	SRAM Chip Enable
output			oSRAM_CE3_N;        	//	SRAM Chip Enable
output			oSRAM_CLK;              //	SRAM Clock
output			oSRAM_GW_N;         	//  SRAM Global Write Enable
output			oSRAM_OE_N;         	//	SRAM Output Enable
output			oSRAM_WE_N;         	//	SRAM Write Enable
////////////////////	ISP1362 Interface	////////////////////////
inout	[15:0]	OTG_D;					//	ISP1362 Data bus 16 Bits
output	[1:0]	oOTG_A;					//	ISP1362 Address 2 Bits
output			oOTG_CS_N;				//	ISP1362 Chip Select
output			oOTG_OE_N;				//	ISP1362 Read
output			oOTG_WE_N;				//	ISP1362 Write
output			oOTG_RESET_N;			//	ISP1362 Reset
inout			OTG_FSPEED;				//	USB Full Speed,	0 = Enable, Z = Disable
inout			OTG_LSPEED;				//	USB Low Speed, 	0 = Enable, Z = Disable
input			iOTG_INT0;				//	ISP1362 Interrupt 0
input			iOTG_INT1;				//	ISP1362 Interrupt 1
input			iOTG_DREQ0;				//	ISP1362 DMA Request 0
input			iOTG_DREQ1;				//	ISP1362 DMA Request 1
output			oOTG_DACK0_N;			//	ISP1362 DMA Acknowledge 0
output			oOTG_DACK1_N;			//	ISP1362 DMA Acknowledge 1
////////////////////	LCD Module 16X2	////////////////////////////
inout	[7:0]	LCD_D;					//	LCD Data bus 8 bits
output			oLCD_ON;				//	LCD Power ON/OFF
output			oLCD_BLON;				//	LCD Back Light ON/OFF
output			oLCD_RW;				//	LCD Read/Write Select, 0 = Write, 1 = Read
output			oLCD_EN;				//	LCD Enable
output			oLCD_RS;				//	LCD Command/Data Select, 0 = Command, 1 = Data
////////////////////	SD Card Interface	////////////////////////
inout			SD_DAT;					//	SD Card Data
inout			SD_DAT3;				//	SD Card Data 3
inout			SD_CMD;					//	SD Card Command Signal
output			oSD_CLK;				//	SD Card Clock
////////////////////////	I2C		////////////////////////////////
inout			I2C_SDAT;				//	I2C Data
output			oI2C_SCLK;				//	I2C Clock
////////////////////////	PS2		////////////////////////////////
inout		 	PS2_DAT;				//	PS2 Data
inout			PS2_CLK;				//	PS2 Clock
////////////////////////	VGA			////////////////////////////
output			oVGA_CLOCK;   			//	VGA Clock
output			oVGA_HS;				//	VGA H_SYNC
output			oVGA_VS;				//	VGA V_SYNC
output			oVGA_BLANK_N;			//	VGA BLANK
output			oVGA_SYNC_N;			//	VGA SYNC
output	[9:0]	oVGA_R;   				//	VGA Red[9:0]
output	[9:0]	oVGA_G;	 				//	VGA Green[9:0]
output	[9:0]	oVGA_B;   				//	VGA Blue[9:0]
////////////////	Ethernet Interface	////////////////////////////
inout	[15:0]	ENET_D;					//	DM9000A DATA bus 16Bits
output			oENET_CMD;				//	DM9000A Command/Data Select, 0 = Command, 1 = Data
output			oENET_CS_N;				//	DM9000A Chip Select
output			oENET_IOW_N;			//	DM9000A Write
output			oENET_IOR_N;			//	DM9000A Read
output			oENET_RESET_N;			//	DM9000A Reset
input			iENET_INT;				//	DM9000A Interrupt
output			oENET_CLK;				//	DM9000A Clock 25 MHz
////////////////////	Audio CODEC		////////////////////////////
inout			AUD_ADCLRCK;			//	Audio CODEC ADC LR Clock
input			iAUD_ADCDAT;			//	Audio CODEC ADC Data
inout			AUD_DACLRCK;			//	Audio CODEC DAC LR Clock
output			oAUD_DACDAT;			//	Audio CODEC DAC Data
inout			AUD_BCLK;				//	Audio CODEC Bit-Stream Clock
output			oAUD_XCK;				//	Audio CODEC Chip Clock
////////////////////	TV Devoder		////////////////////////////
input			iTD1_CLK27;				//	TV Decoder1 Line_Lock Output Clock 
input	[7:0]	iTD1_D;    				//	TV Decoder1 Data bus 8 bits
input			iTD1_HS;				//	TV Decoder1 H_SYNC
input			iTD1_VS;				//	TV Decoder1 V_SYNC
output			oTD1_RESET_N;			//	TV Decoder1 Reset
input			iTD2_CLK27;				//	TV Decoder2 Line_Lock Output Clock 		
input	[7:0]	iTD2_D;    				//	TV Decoder2 Data bus 8 bits
input			iTD2_HS;				//	TV Decoder2 H_SYNC
input			iTD2_VS;				//	TV Decoder2 V_SYNC
output			oTD2_RESET_N;			//	TV Decoder2 Reset

////////////////////////	GPIO	////////////////////////////////
inout	[31:0]	GPIO_0;					//	GPIO Connection 0 I/O
input			GPIO_CLKIN_N0;     		//	GPIO Connection 0 Clock Input 0
input			GPIO_CLKIN_P0;          //	GPIO Connection 0 Clock Input 1
output			GPIO_CLKOUT_N0;     	//	GPIO Connection 0 Clock Output 0
output			GPIO_CLKOUT_P0;         //	GPIO Connection 0 Clock Output 1
inout	[31:0]	GPIO_1;					//	GPIO Connection 1 I/O
input			GPIO_CLKIN_N1;          //	GPIO Connection 1 Clock Input 0
input			GPIO_CLKIN_P1;          //	GPIO Connection 1 Clock Input 1
output			GPIO_CLKOUT_N1;         //	GPIO Connection 1 Clock Output 0
output			GPIO_CLKOUT_P1;         //	GPIO Connection 1 Clock Output 1
///////////////////////////////////////////////////////////////////
//=============================================================================
// REG/WIRE declarations
//=============================================================================

wire			iRST_n;

wire			oTD1_RESET_N;
wire			oTD2_RESET_N;

wire			TV1_VGA_HS;
wire			TV1_VGA_VS;
wire			TV1_VGA_BLANK;
wire			TV1_VGA_SYNC;
wire	[9:0]	TV1_VGA_R;
wire	[9:0]	TV1_VGA_G;
wire	[9:0]	TV1_VGA_B;


wire			TV2_VGA_HS;
wire			TV2_VGA_VS;
wire			TV2_VGA_BLANK;
wire			TV2_VGA_SYNC;
wire	[9:0]	TV2_VGA_R;
wire	[9:0]	TV2_VGA_G;
wire	[9:0]	TV2_VGA_B;


wire			mvga_hs; 	
wire			mvga_vs; 	
wire			mvga_blank; 	
wire			mvga_sync; 	
wire 	[9:0]	mvga_r;	 	
wire 	[9:0]	mvga_g;	 	
wire 	[9:0]	mvga_b;	 	
wire			mclk_27;


reg				oVGA_HS;
reg				oVGA_VS;
reg				oVGA_BLANK_N;	
reg				oVGA_SYNC_N;
reg 	[9:0]	oVGA_R; 
reg 	[9:0]	oVGA_G;
reg 	[9:0]	oVGA_B; 




wire 			MemON;
wire 			DispPiP;

wire 			CLK_54;
wire 			KEY_OnOff;



wire 	[9:0]	VGA_R_S ;
wire 	[9:0]	VGA_G_S ;
wire 	[9:0]	VGA_B_S ;
                

wire 	[9:0]	VGA_R_S_o;
wire 	[9:0]	VGA_G_S_o;
wire 	[9:0]	VGA_B_S_o;

wire	[9:0] 	mRed_o  ;
wire	[9:0] 	mGreen_o;
wire	[9:0] 	mBlue_o ;

wire 			SDR_SYS_CLK; //SDRAM CONTROLLER CLOCK
wire 			SDR_CLK ;    //SDRAM ISSI CLOCK
wire 			CLK_18  ;    //AUDIO SYSTEM CLOCK

wire 			oVGA1_V_BLANK;
wire 			oVGA2_V_BLANK;
wire 	[10:0] 	VGA1_X;
wire 	[10:0] 	VGA1_Y;
wire 	[10:0] 	VGA2_X;
wire 	[10:0] 	VGA2_Y;
wire 			TV1_VGA_CLOCK;
wire 			TV2_VGA_CLOCK;
wire    [4:0]   NP_POINTER1;
wire    [4:0]   NP_POINTER2;
wire    [4:0]   NP_POINTER;
wire 			Field;
wire 			oSAVE_FRAME;
reg 	[1:0] 	SA,PRE_SA;
reg 			SW_RST;
reg 	[31:0]	CLK_D;

reg     [31:0]  LCD_DELAY;
wire            LCD_RST_n;
//=============================================================================
// Structural coding
//=============================================================================


//=======================================================
//			 UNUSED DATA BUS
//=======================================================


assign GPIO_0  			= 32'hzzzzzzzz;					
          
assign GPIO_CLKOUT_N0 	= 1'bz;     		  	
assign GPIO_CLKOUT_P0 	= 1'bz;     		         
assign GPIO_1			= 32'hzzzzzzzz;				
 		          
assign GPIO_CLKOUT_N1 	= 1'bz;     		         
assign GPIO_CLKOUT_P1  	= 1'bz;     		         
   				
assign ENET_D 			= 16'hzzzz;			
assign PS2_DAT 			= 1'bz;     			
assign PS2_CLK 			= 1'bz;     						
    						
assign SD_DAT 			= 1'bz;     							
assign SD_DAT3 			= 1'bz;     						
assign SD_CMD 			= 1'bz;     						
assign oSD_CLK 			= 1'bz;     						
assign OTG_D   			= 16'hzzzz;	
assign SRAM_DQ 			= 32'hzzzzzzzz;				
assign FLASH_DQ			= 14'hzzzz;				
assign FLASH_DQ15_AM1 	= 1'bz;     				

assign {oHEX0_D ,oHEX0_DP}=8'hff;
assign {oHEX1_D ,oHEX1_DP}=8'hff;
assign {oHEX2_D ,oHEX2_DP}=8'hff;
assign {oHEX3_D ,oHEX3_DP}=8'hff;
assign {oHEX4_D ,oHEX4_DP}=8'hff;
assign {oHEX5_D ,oHEX5_DP}=8'hff;
assign {oHEX6_D ,oHEX6_DP}=8'hff;
assign {oHEX7_D ,oHEX7_DP}=8'hff;

//=======================================================//
//SWITCH OPERATION:										 //
//SW[17:16]=01 :TV1 OUT only							 //
//SW[17:16]=00 :TV2 OUT only							 //	
//SW[17:16]=11 :PIP = TV1 (main) + TV2 (sub)  OUT        //
//SW[17:16]=10 :PIP = TV1 (sub)  + TV2 (main) OUT        //
//=======================================================//



//=======================================================
//			 TV1-CLOCK or TV2-CLOCK x 2
//=======================================================
wire TD_Stable1;
wire TD_Stable2;
wire locked;

pll27 p27_1(
	.areset    ( iSW[16]? ~TD_Stable2 : ~TD_Stable1),
	.clkswitch ( iSW[16] ),
	.inclk0    ( iTD2_CLK27  ),
	.inclk1    ( iTD1_CLK27  ),
	
	.c0        ( CLK_54),
	.c1        ( CLK_18),
	.locked    ( locked)
	);
	


//=======================================================
//			 SDRAM CLOCK 100MHZ
//=======================================================
wire mCLK_50;
Sdram_PLL    p100(
				.inclk0( iCLK_50 ),
				.c0    ( SDR_SYS_CLK ),//100MHZ 0 degree
				.c1    ( SDR_CLK ),    //100MHZ -90 degree
				.c2    ( mCLK_50),     //50MHZ
				);

wire mCLK_18;
wire mCLK_50_2;
wire mCLK_50_3;

	PLL50 P50(
	.inclk0(iCLK_50),
	.c0(mCLK_18),
	.c1(mCLK_50_2),
	.c2(mCLK_50_3)
	
	);				

//=======================================================
//			 SDRAM CLOCK OUT
//=======================================================


assign oDRAM0_CLK = SDR_CLK;
assign oDRAM1_CLK = SDR_CLK;


//=======================================================
//			 TV reset
//=======================================================

assign	iRST_n =iKEY[1];

//=======================================================
//			 NTSC/PAL POINTER
//=======================================================

assign NP_POINTER = ( iSW[16] )?NP_POINTER1 :NP_POINTER2;



//=======================================================
//			 LED POINTER
//=======================================================

//assign oLEDG[2:0]={ SW_RST , Field, oSAVE_FRAME};


//=======================================================
//			SWITCH CHECK AND CHANGE
//=======================================================

always @( posedge mCLK_50) CLK_D = CLK_D+1;



reg SW_RST1;
reg [1:0]SA1;
reg [1:0]PRE_SA1;
reg [1:0]SA2;
reg [1:0]PRE_SA2;


always @( posedge iTD1_VS ) begin
if ( SA1 != PRE_SA1 )  
	begin 
		SW_RST1 = 0;
        PRE_SA1 = SA1;
	end
 else
    begin
		SA1     = iSW[17:16] ;
	    SW_RST1 = 1;
	end
 end

reg SW_RST2;
always @( posedge iTD2_VS ) begin
if ( SA2 != PRE_SA2 )  
	begin 
		SW_RST2 = 0;
        PRE_SA2 = SA2;
	end
 else
    begin
		SA2     = iSW[17:16] ;
	    SW_RST2 = 1;
	end
 end

//=======================================================
//			 TV1 processer
//=======================================================


composite_to_vga	u1	( 
				.TD_Stable(TD_Stable1),
				.SW_RST( SW_RST1 ) ,
				
				.NP_POINTER(NP_POINTER1),
				.Field(Field),
				.oSAVE_FRAME(oSAVE_FRAME),
				.VGA_X(VGA1_X),
				.VGA_Y(VGA1_Y),
			    .oVGA_V_BLANK(oVGA1_V_BLANK),
				.SW( iSW[17] & ~iSW[16] ),
				.MemON  ( ( iSW[17] & ~iSW[16] )? MemON:0    ),      
				.OSC_27( (( !iSW[17] ) || ( iSW[16] ) )?iTD1_CLK27 : CLK_54 ),
								
				.SDR_SYS_CLK(SDR_SYS_CLK),				
                .OSC_50(mCLK_50_2),//iCLK_50  ),				
				.KEY(iKEY),
				
				.DRAM_DQ  (DRAM_DQ[15:0]),
				.DRAM_ADDR(oDRAM0_A[11:0]),	
				.DRAM_LDQM(oDRAM0_LDQM0),	
				.DRAM_UDQM(oDRAM0_UDQM1),	
				.DRAM_WE_N(oDRAM0_WE_N),	
				.DRAM_CAS_N(oDRAM0_CAS_N),	
                .DRAM_RAS_N(oDRAM0_RAS_N),	
                .DRAM_CS_N(oDRAM0_CS_N),	
                .DRAM_BA_0(oDRAM0_BA[0]),	
                .DRAM_BA_1(oDRAM0_BA[1]),	
                //.DRAM_CLK(oDRAM0_CLK),	
                .DRAM_CKE(oDRAM0_CKE),	
               
				.I2C_SDAT(I2C_SDAT),
                .I2C_SCLK(oI2C_SCLK),
		
				.VGA_CLK(TV1_VGA_CLOCK), 
				.VGA_HS(TV1_VGA_HS),
				.VGA_VS(TV1_VGA_VS),	
				.VGA_BLANK(TV1_VGA_BLANK),
                .VGA_SYNC(TV1_VGA_SYNC),
                .VGA_R(TV1_VGA_R),   
                .VGA_G(TV1_VGA_G),	 
                .VGA_B(TV1_VGA_B),   
	
 
				.TD_DATA(iTD1_D),
                .TD_HS(iTD1_HS),	
                .TD_VS(iTD1_VS),	
                .TD_RESET(oTD1_RESET_N),
                .TD_CLK(iTD1_CLK27)	

				);



//=======================================================
//			 TV2 processer
//=======================================================

composite_to_vga	u2	(
				.TD_Stable(TD_Stable2),
				.SW_RST( SW_RST2),
				
			    .NP_POINTER(NP_POINTER2 ),
				.VGA_X( VGA2_X ),
				.VGA_Y( VGA2_Y ),
			    .oVGA_V_BLANK( oVGA2_V_BLANK ),				
				.SW( iSW[17] & iSW[16] ),				
				.MemON ( ( iSW[17] & iSW[16] )? MemON:0   ),                
				.OSC_27( (( !iSW[17] ) || ( !iSW[16] ) )?iTD2_CLK27 : CLK_54 ),				

	            .SDR_SYS_CLK(SDR_SYS_CLK),
                .OSC_50( mCLK_50_2 ),//iCLK_50  ),				
				.KEY( iKEY ),				
				.DRAM_DQ(DRAM_DQ[31:16]),	
				.DRAM_ADDR(oDRAM1_A[11:0]),	
				.DRAM_LDQM(oDRAM1_LDQM0),	
				.DRAM_UDQM(oDRAM1_UDQM1),	
				.DRAM_WE_N(oDRAM1_WE_N),	
				.DRAM_CAS_N(oDRAM1_CAS_N),	
                .DRAM_RAS_N(oDRAM1_RAS_N),	
                .DRAM_CS_N(oDRAM1_CS_N),	
                .DRAM_BA_0(oDRAM1_BA[0]),	
                .DRAM_BA_1(oDRAM1_BA[1]),	
                //.DRAM_CLK(oDRAM1_CLK),	
                .DRAM_CKE(oDRAM1_CKE),	
               
				//.I2C_SDAT(I2C_SDAT),
                //.I2C_SCLK(oI2C_SCLK),
				
				.VGA_CLK(TV2_VGA_CLOCK), 
				.VGA_HS(TV2_VGA_HS),
				.VGA_VS(TV2_VGA_VS),	
				.VGA_BLANK(TV2_VGA_BLANK),
                .VGA_SYNC(TV2_VGA_SYNC),
                .VGA_R(TV2_VGA_R),   
                .VGA_G(TV2_VGA_G),	 
                .VGA_B(TV2_VGA_B),   
 
				.TD_DATA(iTD2_D),
                .TD_HS(iTD2_HS),	
                .TD_VS(iTD2_VS),	
                .TD_RESET(oTD2_RESET_N),
                .TD_CLK(iTD2_CLK27)	

				);




//=======================================================
//			SUB VIDEO 
//=======================================================

assign KEY_OnOff = iSW[17];// PIP ON/OFF

assign VGA_R_S = (iSW[16])?TV2_VGA_R : TV1_VGA_R;
assign VGA_G_S = (iSW[16])?TV2_VGA_G : TV1_VGA_G;
assign VGA_B_S = (iSW[16])?TV2_VGA_B : TV1_VGA_B;
                                  
PipPositionAdj  PipPositionAdj(

	.iVS         ( (iSW[16]  )? ~oVGA1_V_BLANK :~oVGA2_V_BLANK),
	.iPosition_X ( 12'h140   ),
	.iPosition_Y ( 12'hfa    ),	
	.iCLOCK      ( ( iSW[16] )? TV1_VGA_CLOCK:TV2_VGA_CLOCK ),	

	.iDEMO      ( 1'b0),
	.iXoffest   ( Xoffest),
	.iYoffset   ( Yoffest),
	
	.iVGA_R     ( VGA_R_S[9:0]),
	.iVGA_G     ( VGA_G_S[9:0]),
	.iVGA_B     ( VGA_B_S[9:0]),
	
	.oVGA_R     ( VGA_R_S_o[9:0]),
	.oVGA_G     ( VGA_G_S_o[9:0]),
	.oVGA_B     ( VGA_B_S_o[9:0]),
	
	.oMemON    ( MemON),  
	
	.oDispPiP  ( DispPiP),
	.iX ( (iSW[16])?VGA1_X : VGA2_X),
	.iY ( (iSW[16])?VGA1_Y : VGA2_Y)
	                    

);

                                        

//=======================================================
//			TV1-OUT & TV2-OUT selection
//=======================================================


assign	mvga_hs 	= iSW[16] ? TV1_VGA_HS    : TV2_VGA_HS;
assign	mvga_vs 	= iSW[16] ? TV1_VGA_VS    : TV2_VGA_VS;
assign	mvga_blank 	= iSW[16] ? TV1_VGA_BLANK : TV2_VGA_BLANK;
assign	mvga_sync 	= iSW[16] ? TV1_VGA_SYNC  : TV2_VGA_SYNC;
assign	mvga_r	 	= ( iSW[17] && KEY_OnOff && DispPiP )?VGA_R_S_o : ((iSW[16])?TV1_VGA_R : TV2_VGA_R);
assign	mvga_g	 	= ( iSW[17] && KEY_OnOff && DispPiP )?VGA_G_S_o : ((iSW[16])?TV1_VGA_G : TV2_VGA_G);
assign	mvga_b	 	= ( iSW[17] && KEY_OnOff && DispPiP )?VGA_B_S_o : ((iSW[16])?TV1_VGA_B : TV2_VGA_B);
assign	mclk_27		= iSW[16] ? TV1_VGA_CLOCK : TV2_VGA_CLOCK ;



//=======================================================
//			VGA OUT
//=======================================================

assign	oVGA_CLOCK = mclk_27;

always@(posedge mclk_27 or negedge iRST_n)
	begin
		if(!iRST_n)
			begin
				oVGA_HS	<= 0;	
				oVGA_VS	<= 0;	
				oVGA_BLANK_N	<= 0;
				oVGA_SYNC_N	<= 0;
				oVGA_R	<= 0;   	
				oVGA_G	<= 0;	 	
				oVGA_B	<= 0; 
			end
		else
			begin
				oVGA_HS	<= mvga_hs;	
				oVGA_VS	<= mvga_vs;	
				oVGA_BLANK_N	<= mvga_blank;
				oVGA_SYNC_N	<= mvga_sync;
				oVGA_R	<= mvga_r;   	
				oVGA_G	<= mvga_g;	 	
				oVGA_B	<= mvga_b; 			
			end
	end
	
//=======================================================
//			This is audio fucntion
//=======================================================

assign	AUD_ADCLRCK		=	AUD_DACLRCK;
assign	oAUD_XCK		=	CLK_18;


// Audio 
   
AUDIO_DAC 	u3		(	//	Audio Side
					.iAUD_DATA( iAUD_ADCDAT ),
					.iAUD_LRCK( AUD_ADCLRCK ),
					.oAUD_BCK ( AUD_BCLK    ),
					.oAUD_DATA( oAUD_DACDAT ),
					.oAUD_LRCK( AUD_DACLRCK ),
					//	Control Signals
					.iSrc_Select ( iKEY[2] ),
			        .iCLK_18_4   ( CLK_18 ),
					.iRST_N(iKEY[0]),
	
					.oLED_PTR( oLEDR[17:0])
					);

	
	
	
//=======================================================
//			This is LCD fucntion
//=======================================================
assign	oLCD_ON		  =	1'b1;	//	LCD Power ON
assign	oLCD_BLON	  =	1'b1;	//	LCD Back Light ON	
assign  LCD_RST_n     = LCD_DELAY[23]; // LCD RESET


always @(negedge iKEY[0] or posedge iTD1_CLK27) begin
	if (!iKEY[0]) 
		LCD_DELAY=0;
	else if (!LCD_DELAY[23]) 
		LCD_DELAY=LCD_DELAY+1;
end

LCD_TEST 			u7	(	//	Host Side
							.iCLK  ( iTD1_CLK27    ),
							.iRST_N( LCD_RST_n     ),
							//	LCD Side
							.LCD_DATA(LCD_D),
							.LCD_RW(oLCD_RW),
							.LCD_EN(oLCD_EN),
							.LCD_RS(oLCD_RS)	);
	
endmodule

